function [lnlik, store_beta, store_P, Q] = conditional_kf1(xcand, param, postheta, possig, posq, xdd, ST, sig, other_specifications, idx_spec)

t = size(xdd,1);
param(postheta)=xcand;
param(possig)=sig(:);
param(posq)=NaN*ones(param(end),1);
nstates = param(end);
nvarobs = size(xdd,2);

% Justiniano, Primiceri and Tambalotti (2011, RED)  with MS
[F,CC,impact,eu,SDX,P,H,NY,NX,NETA] = eval(['modptj',num2str(nstates),'v',other_specifications,'(param)']);

%%%%

xxx = [ones(1,NX);repmat(idx_spec,nstates-1,1)];
sxx = find(xxx');

sig1       = repmat(sig(1:NX),1,nstates); 
sig1(sxx)  = sig;
sig1       = reshape(sig1,NX,nstates);

%%%%

Q = zeros(NY,NY,nstates);
for ii=1:nstates
    Q(:,:,ii)  = impact*(diag(sig1(:,ii).^2))*impact';
end

% Measurement equation y_t = MU + H_t.B_t 
%--------------------------------------------------------------
R  = 0;
t0 = 4;
C  = H*CC;

% Initializing Kalman Filter
%--------------------------------------------------------------
beta_ll = zeros(NY,1);
P_ll    = dlyapgio(F,Q(:,:,ST(1)));

% The sample log-likelihood function
%--------------------------------------------------------------
lik_mat = zeros(t,1);  store_beta=zeros(NY,t); store_P=zeros(NY,NY,t);

for j=1:t
  
  %Prediction -------------------------------------------------
  beta_tl = F*beta_ll;
  P_tl=F*P_ll*F'+Q(:,:,ST(j));
  vt=xdd(j,:)'- C - H*beta_tl; %prediction error (r x 1) vector
  ft=H*P_tl*H'+R; %variance of forecast error (r x r) matrix

  %Updating ---------------------------------------------------
  beta_tt = beta_tl+P_tl*H'/ft*vt;
  P_tt=P_tl-P_tl*H'/ft*H*P_tl;

  %likelihood -------------------------------------------------
  if j>t0
    lik_mat(j,1)=-0.5*(nvarobs*log(2*pi) + log(det(ft)) + vt'/ft*vt);
  end
  
  beta_ll         = beta_tt;
  store_beta(:,j) = beta_tt;
  
  P_ll           = P_tt;
  store_P(:,:,j) = P_tt;
    
end

lnlik = sum(lik_mat(1:t,1));



