% Generate transition probabilities conditonal on St
%
% Stephane Lhuissier, 2015

function Q = gen_q(pmean,pstdd,st,nstates)

m = size(pmean,1);
a = zeros(m,1);
b = zeros(m,1);
Q = zeros(nstates,nstates);

for ii=1:m
    a(ii) = (1-pmean(ii))*pmean(ii)^2/pstdd(ii)^2-pmean(ii);
    b(ii) = a(ii)*(1/pmean(ii)-1);
end

change_nbr = switchg(st,nstates);

Q(1,1) = betarnd(change_nbr(1,1)+a(1),change_nbr(1,2)+b(1));
Q(2,2) = betarnd(change_nbr(2,2)+a(2),change_nbr(2,1)+b(2));

Q(2,1) = 1-Q(1,1);
Q(1,2) = 1-Q(2,2);
