function Q = gen_q(pmean,pstdd,st,m,nstates)
% Generate transition probabilities conditonal on St
%
% Stephane Lhuissier, 2015

Qres = zeros(2,nstates); % always equal to (2,2) matrix because of restrictions
Q    = zeros(nstates,nstates);

change_nbr = switchg(st,nstates);

change_nbr1      = zeros(2,nstates);
change_nbr1(1,:) = diag(change_nbr)';
change_nbr1(2,:) = sum(change_nbr,1)-change_nbr1(1,:);

for ii=1:nstates
     a = (1-pmean(ii))*pmean(ii)^2/pstdd(ii)^2-pmean(ii);
     b = a*(1/pmean(ii)-1);
     alpha_bar  = [a b];  
     Qres(:,ii) = drchrnd(change_nbr1(:,ii)' + alpha_bar,1); % dim = 2, so it is a Beta distribution 
     Q(:,ii)    = m{ii}*Qres(:,ii); % see SWZ, 2008, JoE. 
end

