function parasim = gen_sig1(ST, xddsim, F, impact, a_invgam, b_invgam, nstates, idx_specification)
% generate structural shocks
%
% by Stphane Lhuissier, 2015

nshocks = size(impact,2);
parasim = zeros(nshocks,nstates);

% structural shocks, nshocks x T
e = pinv(impact)*(xddsim(2:end,:)'-F*xddsim(1:end-1,:)');

% remove one period
ST = ST(2:end);

%idx_accept = 0;

%while idx_accept == 0
%k = 1;         
% draws from inverse-gamma distribution
for ns=1:nstates 
    RR = find(ST==ns);
    
    if ns == 1 % REGIME 1
    k = 1;     
    for jj=1:nshocks

        if ns == 1 && idx_specification(jj) == 0 
            ee = e(jj,:);
            t  = size(ee,2);
        else
            ee = e(jj,RR);
            t = size(ee,2);
        end

        if ns >=2 && idx_specification(jj) == 0
            parasim(jj,ns) = parasim(jj,1); % or as state=1
        else
            
            s_R1  = a_invgam(k) + ee*ee';
            nu_R1 = b_invgam(k) + t;
            
            parasim(jj,ns) = gen_ig1_dyn(s_R1,nu_R1);
            
            %a = a_invgam(k) + 1/2*t;
            %b = b_invgam(k) + 1/2*(ee*ee');

            %parasim(jj,ns) = sqrt(1./gamrnd(a,1/b)); %Note that in Matlab, it is 1/b, NOT b.
        end
        k = k + 1; 
    end
    end


    if ns >= 2 % REGIME 2 OR MORE
    k = 1; 
    for jj=1:nshocks
        idx_accept = 0;
        while idx_accept == 0

        if ns == 1 && idx_specification(jj) == 0 
            ee = e(jj,:);
            t  = size(ee,2);
        else
            ee = e(jj,RR);
            t = size(ee,2);
        end

        if ns >=2 && idx_specification(jj) == 0
            parasim(jj,ns) = parasim(jj,1); % or as state=1
        else
            
            s_R2  = a_invgam(k) + ee*ee';
            nu_R2 = b_invgam(k) + t;
            
            parasim(jj,ns) = gen_ig1_dyn(s_R2,nu_R2);
            
            %a = a_invgam(k) + 1/2*t;
            %b = b_invgam(k) + 1/2*(ee*ee');

            %parasim(jj,ns) = sqrt(1./gamrnd(a,1/b)); %Note that in Matlab, it is 1/b, NOT b.
        end
        
        %%% normalization rule, see HWZ
        if ns==2 
            %jj
            %parasim(jj,2)
            %parasim(jj,1)
            if parasim(jj,1) >= parasim(jj,2)
                idx_accept = 1;
            end
        end
        if ns==3 
            if parasim(jj,2) >= parasim(jj,3)
                idx_accept = 1;
            end
        end
        
        end
        k = k + 1;
    end
    end        
end
        