function [parasim,e] = gen_sig1_dyn(ST, xddsim, F, impact, s_invgam, nu_invgam, nstates)
% generate structural shocks
%
% by Stphane Lhuissier, 2017

nshocks = size(impact,2);
parasim = zeros(nshocks,nstates);

s_invgam  = reshape(s_invgam,nshocks,nstates);%
nu_invgam = reshape(nu_invgam,nshocks,nstates);%

% structural shocks, nshocks x T
e = pinv(impact)*(xddsim(2:end,:)'-F*xddsim(1:end-1,:)');

% remove one period
ST = ST(2:end);

R1 = ST==1;
R2 = ST==2;
  
for jj=1:nshocks
	idx_accept = 0;
	while idx_accept == 0

    % REGIME 1
	ee_R1 = e(jj,R1);
	t_R1 = size(ee_R1,2);

    s1_invgam  = s_invgam(jj,1) +  ee_R1*ee_R1';
    nu1_invgam = nu_invgam(jj,1)+ t_R1; 

    parasim(jj,1) = gen_ig1_dyn(s1_invgam,nu1_invgam);

	% REGIME 2
	ee_R2 = e(jj,R2);
	t_R2 = size(ee_R2,2);


    s1_invgam  = s_invgam(jj,2) +  ee_R2*ee_R2';
    nu1_invgam = nu_invgam(jj,2)+ t_R2;

    parasim(jj,2) = gen_ig1_dyn(s1_invgam,nu1_invgam);
    
	% HWZ normalization
	if parasim(jj,1) >= parasim(jj,2)
        idx_accept = 1;
	end
	end
end
  