function ST = gen_st(nstates, xdd, F, impact, SDX, Q)
% Generating S_T conditional on sig, p, y_T
%
% by Stephane Lhuissier, 2015



%==========DERIVE FILTERED PROBABILTIES FROM REDUCED-FORM VAR(1) MODEL=====

[~, ~, pr_st0, ~] = lik_ms_sbvar_svd(xdd, F, impact, SDX, Q, nstates);


%===================GENERATE S_T BASED ON CARTER & KOHN (1994)=============

t  = size(xdd,1);
ST = zeros(t,1);

idx_accept = 0;

%while idx_accept == 0

ST(t,1) = bingen1(pr_st0(t,:));

J_ITER=t-1; 
while J_ITER>=1
    
    Prob = zeros(1,nstates);
    idx_state = ST(J_ITER+1,1);
    
    for i_iter = 1:nstates
        Prob(1,i_iter) = Q(idx_state,i_iter)*pr_st0(J_ITER,i_iter);
    end
    
    ST(J_ITER,1)=bingen1(Prob);

    J_ITER=J_ITER-1;
end

%     % trying this!
%     if ~any(ST==1) || ~any(ST==2) || ~any(ST==3)
%         idx_accept = 0;
%     else 
%         idx_accept = 1;
%     end
    
%end


% Ex: The case for DIM = 2 ************************************************
% J_ITER=t-1; 
% while J_ITER>=1
% 
%     if ST(J_ITER+1,1)==0
%                     P0=QPR*pr_st0(J_ITER,1);
%                     P1=(1-PPR)*pr_st0(J_ITER,2);
%     elseif ST(J_ITER+1,1)==1;
%                     P0=(1-QPR)*pr_st0(J_ITER,1);
%                     P1=PPR*pr_st0(J_ITER,2);
%     end
%  
%     %ST(J_ITER,1)=bingen(P0,P1,1);
%     [P0 P1]
%     ST(J_ITER,1)=bingen1([P0 P1])-1
%     
%     J_ITER=J_ITER-1;
% end
