function  [y, cost_flag, logLikelihood] = logpostMSDSGE(pzero, opts, flag_min)

global bayestopt_

cost_flag = 1;

%xparam = opts.param;

% If minimization, transform the unconstrained into a constrained minimization
%xparam(opts.posest)=pzero;

% If any parameters are fixed, they are set here:
% if opts.blockwise
% 	xparam = xparam.*opts.maskinv.*opts.tblock + opts.sp.*opts.tblockinv;
% else
% 	xparam = xparam.*opts.maskinv + opts.fix.*opts.mask;
% end

%if flag_min == 1
    % Return, with endogenous penalty, if some parameters are smaller than the lower bound of the prior domain.
    if  any(pzero<opts.lb)
        k = find(pzero<opts.lb);
	    
        y = bayestopt_.penalty + sum((opts.lb(k)-pzero(k)).^2);
        cost_flag = 0;
        return
    end

    % Return, with endogenous penalty, if some parameters are greater than the upper bound of the prior domain.
    if  any(pzero>opts.ub)
        k = find(pzero>opts.ub);
        y = bayestopt_.penalty + sum((pzero(k)-opts.ub(k)).^2);
        cost_flag = 0;
        return
    end
 
% ************************************************************************* 
    
% else
%     
%     % Return, with endogenous penalty, if some parameters are smaller than the lower bound of the prior domain.
%     if  any(xparam<opts.lb)
%         y = -1E6;
%         return
%     end
% 
%     % Return, with endogenous penalty, if some parameters are greater than the upper bound of the prior domain.
%     if  any(xparam>opts.ub)        
%         y = -1E6;
%         return
%     end    
% end

if opts.post == 1
    
 xparam = opts.param;
 xparam(opts.posest)=pzero;
 
 logLikelihood = ms_lik_fc(xparam,opts);
 logPrior      = priodens(xparam, opts.pmean, opts.pstdd, opts.pshape);

y = real(logLikelihood+logPrior);

else
	
 logLikelihood = feval(opts.name_lik,xparam, opts);
 y = real(logLikelihood);

end

if flag_min==1
    y=-1*y;
end
