function  [y, cost_flag] = min_post(xparam, opts)

global bayestopt_

cost_flag = 1;


% Return, with endogenous penalty, if some parameters are smaller than the lower bound of the prior domain.
if  any(xparam<opts.lb)
    k = find(xparam<opts.lb);
	    
    y = bayestopt_.penalty + sum((opts.lb(k)-xparam(k)).^2);
    cost_flag = 0;
    return
end

% Return, with endogenous penalty, if some parameters are greater than the upper bound of the prior domain.
if  any(xparam>opts.ub)
    k = find(xparam>opts.ub);
    y = bayestopt_.penalty + sum((xparam(k)-opts.ub(k)).^2);
    cost_flag = 0;
    return
end

	

if opts.post == 1

 %logLikelihood = benchmark_lik_ms(xparam, opts);
 logLikelihood = feval(opts.name_lik,xparam, opts);
 logPrior = priodens(xparam, opts.pmean, opts.pstdd, opts.pshape);

y = real(-logLikelihood-logPrior);

else
	
 %logLikelihood = benchmark_lik_ms(xparam, opts);
 logLikelihood = feval(opts.name_lik,xparam, opts);
 y = real(-logLikelihood);

end