%Benchmark priors
% 0, fixed parameter
% 1, Beta, "mean, std"
% 2, GAMMA, "mean, std"
% 3, Normal, "mean, std"
% 4, invgamma, "(s^2,nu)"
% 5, uniform, "a, b"
% 6, Dirichlet "ai, ...,an"

prior    = [   3    0.27	0.30            0.05      -5.00          5.00    0		0   1 % share of capital in the prod. function    
               0    0.025	0.50            0.15       1E-5      0.999999    1  0.025   0 % capital depreciation rate
               1    0.15	0.50            0.15       1E-5      0.999999    0		0   1 % price indexation
               1    0.07	0.50            0.15       1E-5      0.999999	 0		0   1 % wage indexation  
               3    0.34	0.35           0.025      -10.0         10.00	 0		0   1 % SS technology growth rate
               3    0.05	0.05           0.025      -10.0         10.00	 0		0   1 % steady state growth rate of capital embodied technology
               1    0.41    0.50  	        0.10       1E-5      0.999999	 0		0   1 % consumption habit   
               0    0.20	0.15            0.05      -10.0         10.00	 1	 0.20   0 % steady state of mark-up shock (pins down steady state of wages)      
               0    0.35	0.15            0.05      -10.0         10.00	 1	 0.35   0 % wage mark-up     
               3    0.00	0.00           0.025      -10.0         10.00    0		0   1 % steady state for leisure (the ss for leisure is pinned down by psiss. convenient to parameterize the model in terms of Lss)
               3    1.23  	1.25            0.10      -5.00          5.00	 0		0   1 % steady state quarterly inflation (multiplied by 100)      
               1    0.14	0.25            0.10       1E-5      0.999999    0	    0   1 % weird parameter of SW that is a function of beta and the steady state quarterly real rate of interest (ensures that beta is less than 1), 0.12       
               0    0.20	0.20            0.10       1E-5      0.999999	 1	 0.20   0 % steady state of the public spending shock
               2    5.05	2.00        	0.75       1E-5      10.00000    0		0   1 % curvature of the utility function for leisure
               1    0.93	0.66            0.10       1E-5      0.999999    0		0   1 % price stickiness 
               1    0.82	0.66            0.10       1E-5      0.999999    0		0   1 % wage stickiness       
               2    5.02	5.00            0.50       1E-5      10.00000	 0		0   1 % elasticity of the capital utilization cost function   
               2    4.76	4.00            1.00       1E-5      10.00000	 0		0   1 % investment adjustment cost        
               3    1.76	1.70            0.30       1.00         10.00    0		0   1 % reaction to inflation
               3    0.13	0.125           0.05        -10         10.00    0		0   1 % reaction to output gap
               1    0.91	0.60            0.20       1E-5      0.999999	 0		0   1 % rhoR    
               1    0.13	0.40            0.20       1E-5      0.999999	 0		0   1 % rhoz
               0    0.99	0.60            0.20       1E-5      0.999999	 1   0.99   0 % rhog
               1    0.28	0.20            0.10       1E-5      0.999999	 0		0   1 % rhomiu
			   1    0.73    0.60            0.20       1E-5      0.999999    0      0   1 % rholamdap
               1    0.99	0.60            0.20       1E-5      0.999999	 0		0   1 % rhopsi
               1    0.89	0.60            0.20       1E-5      0.999999	 0		0   1 % rhob
               1    0.60    0.50            0.20       1E-5      0.999999    0		0   1 % rhoARMAlambdap
               1    0.96    0.50            0.20	   1E-5      0.999999    0		0   1 % rhoARMApsi
			   3    0.31    0.125           0.05      -10.0         10.00	 0		0   1 % reaction to output gap growth (like in SW)
			   0    0.00    0.10            2.00	   0.00         15.00	 1	 0.00   0 % autocorrelation of MP shock
			   1    0.55    0.60            0.20       1E-5         15.00    0		0   1 % rho MEI
			   0    1.00    0.10            2.00       1E-5         15.00	 1	 1.00   0 % flag_relpiobs
               4    0.25    0.0264        2.0253      1E-10        400.00	 0		0   2 % monetary policy (sdr) st=1 with mu=0.2 and std=1
               4    1.00    1.1782        2.5891      1E-10        400.00    0		0   2 % natural technology growth (sdz) st=1 with mu=1 and std=1
			   4    0.70    1.1782        2.5891      1E-10        400.00	 0		0   2 % governement spending (sdg) st=1
			   4    0.55    0.0264        2.0253      1E-10        400.00	 0		0   2 % investment (ISTS) st=1
			   4    0.30    0.0264        2.0253      1E-10        400.00	 0		0   2 % price markup (sdlambdap) st=1
			   4    0.30    0.0264        2.0253      1E-10        400.00	 0		0   2 % wage markup (sdlambdaw) st=1
			   4    0.04    0.0264        2.0253      1E-10        400.00	 0		0   2 % intertemporal preference (sdb) st=1
               4    7.50    1.1782        2.5891      1E-10        400.00	 0		0   2 % MEI st=1
               4    0.10    0.0264        2.0253      1E-10        400.00	 0		0   2 % monetary policy (sdr) st=2
               4    0.60    1.1782        2.5891      1E-10        400.00	 0		0   2 % natural technology growth (sdz) st=2
			   4    0.30    1.1782        2.5891      1E-10        400.00	 0		0   2 % governement spending (sdg) st=2
			   4    0.20    0.0264        2.0253      1E-10        400.00	 0		0   2 % investment (ISTS) st=2
			   4    0.10    0.0264        2.0253      1E-10        400.00	 0		0   2 % price markup (sdlambdap) st=2
			   4    0.10    0.0264        2.0253      1E-10        400.00	 0		0   2 % wage markup (sdlambdaw) st=2
			   4    0.01    0.0264        2.0253      1E-10        400.00	 0		0   2 % intertemporal preference (sdb) st=2
               4    4.50    1.1782        2.5891      1E-10        400.00	 0		0   2 % MEI st=2
               1    0.90      0.90          0.06       1E-5      0.999999    0 	    0   3 % p11 
               1    0.90      0.90          0.06       1E-5      0.999999    0 	    0   3 % p22
               0    2.00      0.90          0.08 	   1E-5         15.00    1 	    2   0]; % nstates

