function ST = gbs_s(xh,y,x)
% Generating S_T conditional on 
%
% by Stephane Lhuissier, 2018

[~, pr_st0, ~, Q] =  ms_lik(xh, y, x);
ns=size(Q,1);

%===================GENERATE S_T BASED ON CARTER & KOHN (1994)=============
t=size(y,1);
ST=zeros(t,1);

ST(t,1) = bingen1(pr_st0(t,:));

J_ITER=t-1; 
while J_ITER>=1
    
    Prob = zeros(1,ns);
    idx_state = ST(J_ITER+1,1);
    
    for i_iter = 1:ns
        Prob(1,i_iter) = Q(idx_state,i_iter)*pr_st0(J_ITER,i_iter);
    end
    
    ST(J_ITER,1)=bingen1(Prob);

    J_ITER=J_ITER-1;
end

